﻿;------------------------------------------------------------------
; https://www.autohotkey.com/boards/viewtopic.php?p=393308#p393308  by sobuj53
; Take a 4-digit language code or (if no parameter) the current language code and return the corresponding 2-digit ISO code
GetISOLanguageCode(lang := 0) {
global   
LanguageCodeArray := { 0436: "af" ; Afrikaans
			, 041c: "sq" ; Albanian
			, 0401: "ar" ; Arabic_Saudi_Arabia
			, 0801: "ar" ; Arabic_Iraq
			, 0c01: "ar" ; Arabic_Egypt
			, 1001: "ar" ; Arabic_Libya
			, 1401: "ar" ; Arabic_Algeria
			, 1801: "ar" ; Arabic_Morocco
			, 1c01: "ar" ; Arabic_Tunisia
			, 2001: "ar" ; Arabic_Oman
			, 2401: "ar" ; Arabic_Yemen
			, 2801: "ar" ; Arabic_Syria
			, 2c01: "ar" ; Arabic_Jordan
			, 3001: "ar" ; Arabic_Lebanon
			, 3401: "ar" ; Arabic_Kuwait
			, 3801: "ar" ; Arabic_UAE
			, 3c01: "ar" ; Arabic_Bahrain
			, 042c: "az" ; Azeri_Latin
			, 082c: "az" ; Azeri_Cyrillic
			, 042d: "eu" ; Basque
			, 0423: "be" ; Belarusian
			, 0402: "bg" ; Bulgarian
			, 0403: "ca" ; Catalan
			, 0404: "zh-CN" ; Chinese_Taiwan
			, 0804: "zh-CN" ; Chinese_PRC
			, 0c04: "zh-CN" ; Chinese_Hong_Kong
			, 1004: "zh-CN" ; Chinese_Singapore
			, 1404: "zh-CN" ; Chinese_Macau
			, 041a: "hr" ; Croatian
			, 0405: "cs" ; Czech
			, 0406: "da" ; Danish
			, 0413: "nl" ; Dutch_Standard
			, 0813: "nl" ; Dutch_Belgian
			, 0409: "en" ; English_United_States
			, 0809: "en" ; English_United_Kingdom
			, 0c09: "en" ; English_Australian
			, 1009: "en" ; English_Canadian
			, 1409: "en" ; English_New_Zealand
			, 1809: "en" ; English_Irish
			, 1c09: "en" ; English_South_Africa
			, 2009: "en" ; English_Jamaica
			, 2409: "en" ; English_Caribbean
			, 2809: "en" ; English_Belize
			, 2c09: "en" ; English_Trinidad
			, 3009: "en" ; English_Zimbabwe
			, 3409: "en" ; English_Philippines
			, 0425: "et" ; Estonian
			, 040b: "fi" ; Finnish
			, 040c: "fr" ; French_Standard
			, 080c: "fr" ; French_Belgian
			, 0c0c: "fr" ; French_Canadian
			, 100c: "fr" ; French_Swiss
			, 140c: "fr" ; French_Luxembourg
			, 180c: "fr" ; French_Monaco
			, 0437: "ka" ; Georgian
			, 0407: "de" ; German_Standard
			, 0807: "de" ; German_Swiss
			, 0c07: "de" ; German_Austrian
			, 1007: "de" ; German_Luxembourg
			, 1407: "de" ; German_Liechtenstein
			, 0408: "el" ; Greek
			, 040d: "iw" ; Hebrew
			, 0439: "hi" ; Hindi
			, 040e: "hu" ; Hungarian
			, 040f: "is" ; Icelandic
			, 0421: "id" ; Indonesian
			, 0410: "it" ; Italian_Standard
			, 0810: "it" ; Italian_Swiss
			, 0411: "ja" ; Japanese
			, 0412: "ko" ; Korean
			, 0426: "lv" ; Latvian
			, 0427: "lt" ; Lithuanian
			, 042f: "mk" ; Macedonian
			, 043e: "ms" ; Malay_Malaysia
			, 083e: "ms" ; Malay_Brunei_Darussalam
			, 0414: "no" ; Norwegian_Bokmal
			, 0814: "no" ; Norwegian_Nynorsk
			, 0415: "pl" ; Polish
			, 0416: "pt" ; Portuguese_Brazilian
			, 0816: "pt" ; Portuguese_Standard
			, 0418: "ro" ; Romanian
			, 0419: "ru" ; Russian
			, 081a: "sr" ; Serbian_Latin
			, 0c1a: "sr" ; Serbian_Cyrillic
			, 041b: "sk" ; Slovak
			, 0424: "sl" ; Slovenian
			, 040a: "es" ; Spanish_Traditional_Sort
			, 080a: "es" ; Spanish_Mexican
			, 0c0a: "es" ; Spanish_Modern_Sort
			, 100a: "es" ; Spanish_Guatemala
			, 140a: "es" ; Spanish_Costa_Rica
			, 180a: "es" ; Spanish_Panama
			, 1c0a: "es" ; Spanish_Dominican_Republic
			, 200a: "es" ; Spanish_Venezuela
			, 240a: "es" ; Spanish_Colombia
			, 280a: "es" ; Spanish_Peru
			, 2c0a: "es" ; Spanish_Argentina
			, 300a: "es" ; Spanish_Ecuador
			, 340a: "es" ; Spanish_Chile
			, 380a: "es" ; Spanish_Uruguay
			, 3c0a: "es" ; Spanish_Paraguay
			, 400a: "es" ; Spanish_Bolivia
			, 440a: "es" ; Spanish_El_Salvador
			, 480a: "es" ; Spanish_Honduras
			, 4c0a: "es" ; Spanish_Nicaragua
			, 500a: "es" ; Spanish_Puerto_Rico
			, 0441: "sw" ; Swahili
			, 041d: "sv" ; Swedish
			, 081d: "sv" ; Swedish_Finland
			, 0449: "ta" ; Tamil
			, 041e: "th" ; Thai
			, 041f: "tr" ; Turkish
			, 0422: "uk" ; Ukrainian
			, 0420: "ur" ; Urdu
			, 042a: "vi"} ; Vietnamese
   If(lang)
     Return LanguageCodeArray[lang]
   Else Return LanguageCodeArray[A_Language]
}
;-------------------------------------------------------------
GetISOLongnameCode(lang := 0) {
global   
LanguageLongnameArray := { 0436: "Afrikaans"
			, 041c: "Albanian"
			, 0401: "Arabic_Saudi_Arabia"
			, 0801: "Arabic_Iraq"
			, 0c01: "Arabic_Egypt"
			, 1001: "Arabic_Libya"
			, 1401: "Arabic_Algeria"
			, 1801: "Arabic_Morocco"
			, 1c01: "Arabic_Tunisia"
			, 2001: "Arabic_Oman"
			, 2401: "Arabic_Yemen"
			, 2801: "Arabic_Syria"
			, 2c01: "Arabic_Jordan"
			, 3001: "Arabic_Lebanon"
			, 3401: "Arabic_Kuwait"
			, 3801: "Arabic_UAE"
			, 3c01: "Arabic_Bahrain"
			, 042c: "Azeri_Latin"
			, 082c: "Azeri_Cyrillic"
			, 042d: "Basque"
			, 0423: "Belarusian"
			, 0402: "Bulgarian"
			, 0403: "Catalan"
			, 0404: "Chinese_Taiwan"
			, 0804: "Chinese_PRC"
			, 0c04: "Chinese_Hong_Kong"
			, 1004: "Chinese_Singapore"
			, 1404: "Chinese_Macau"
			, 041a: "Croatian"
			, 0405: "Czech"
			, 0406: "Danish"
			, 0413: "Dutch_Standard"
			, 0813: "Dutch_Belgian"
			, 0409: "English_United_States"
			, 0809: "English_United_Kingdom"
			, 0c09: "English_Australian"
			, 1009: "English_Canadian"
			, 1409: "English_New_Zealand"
			, 1809: "English_Irish"
			, 1c09: "English_South_Africa"
			, 2009: "English_Jamaica"
			, 2409: "English_Caribbean"
			, 2809: "English_Belize"
			, 2c09: "English_Trinidad"
			, 3009: "English_Zimbabwe"
			, 3409: "English_Philippines"
			, 0425: "Estonian"
			, 040b: "Finnish"
			, 040c: "French_Standard"
			, 080c: "French_Belgian"
			, 0c0c: "French_Canadian"
			, 100c: "French_Swiss"
			, 140c: "French_Luxembourg"
			, 180c: "French_Monaco"
			, 0437: "Georgian"
			, 0407: "German_Standard"
			, 0807: "German_Swiss"
			, 0c07: "German_Austrian"
			, 1007: "German_Luxembourg"
			, 1407: "German_Liechtenstein"
			, 0408: "Greek"
			, 040d: "Hebrew"
			, 0439: "Hindi"
			, 040e: "Hungarian"
			, 040f: "Icelandic"
			, 0421: "Indonesian"
			, 0410: "Italian_Standard"
			, 0810: "Italian_Swiss"
			, 0411: "Japanese"
			, 0412: "Korean"
			, 0426: "Latvian"
			, 0427: "Lithuanian"
			, 042f: "Macedonian"
			, 043e: "Malay_Malaysia"
			, 083e: "Malay_Brunei_Darussalam"
			, 0414: "Norwegian_Bokmal"
			, 0814: "Norwegian_Nynorsk"
			, 0415: "Polish"
			, 0416: "Portuguese_Brazilian"
			, 0816: "Portuguese_Standard"
			, 0418: "Romanian"
			, 0419: "Russian"
			, 081a: "Serbian_Latin"
			, 0c1a: "Serbian_Cyrillic"
			, 041b: "Slovak"
			, 0424: "Slovenian"
			, 040a: "Spanish_Traditional_Sort"
			, 080a: "Spanish_Mexican"
			, 0c0a: "Spanish_Modern_Sort"
			, 100a: "Spanish_Guatemala"
			, 140a: "Spanish_Costa_Rica"
			, 180a: "Spanish_Panama"
			, 1c0a: "Spanish_Dominican_Republic"
			, 200a: "Spanish_Venezuela"
			, 240a: "Spanish_Colombia"
			, 280a: "Spanish_Peru"
			, 2c0a: "Spanish_Argentina"
			, 300a: "Spanish_Ecuador"
			, 340a: "Spanish_Chile"
			, 380a: "Spanish_Uruguay"
			, 3c0a: "Spanish_Paraguay"
			, 400a: "Spanish_Bolivia"
			, 440a: "Spanish_El_Salvador"
			, 480a: "Spanish_Honduras"
			, 4c0a: "Spanish_Nicaragua"
			, 500a: "Spanish_Puerto_Rico"
			, 0441: "Swahili"
			, 041d: "Swedish"
			, 081d: "Swedish_Finland"
			, 0449: "Tamil"
			, 041e: "Thai"
			, 041f: "Turkish"
			, 0422: "Ukrainian"
			, 0420: "Urdu"
			, 042a: "Vietnamese"}
   If(lang)
     Return LanguageLongnameArray[lang]
   Else Return LanguageLongnameArray[A_Language]
}
;-----------------------------------------------------------------
GetISOCodeA(lang) {
LanguageCodeArray := { af: "Afrikaans"
	, sq: "Albanisch"
	, am: "Amharisch"
	, ar: "Arabisch"
	, hy: "Armenisch"
	, az: "Aserbaidschanisch"
	, as: "Assamesisch"
	, ay: "Aymara"
	, bm: "Bambara"
	, eu: "Baskisch"
	, be: "Belarussisch"
	, bn: "Bengalisch"
	, bho: "Bhojpuri"
	, my: "Birmanisch"
	, bs: "Bosnisch"
	, bg: "Bulgarisch"
	, ceb: "Cebuano"
	, ny: "Chichewa"
	, zh-TW: "Chinesisch (traditionell)"
	, zh-CN: "Chinesisch (vereinfacht)"
	, da: "Dänisch"
	, de: "Deutsch"
	, dv: "Dhivehi"
	, doi: "Dogri"
	, en: "Englisch"
	, eo: "Esperanto"
	, et: "Estnisch"
	, ee: "Ewe"
	, tl: "Filipino"
	, fi: "Finnisch"
	, fr: "Französisch"
	, fy: "Friesisch"
	, gl: "Galizisch"
	, ka: "Georgisch"
	, el: "Griechisch"
	, gn: "Guarani"
	, gu: "Gujarati"
	, ht: "Haitianisch"
	, ha: "Hausa"
	, haw: "Hawaiisch"
	, iw: "Hebräisch"
	, hi: "Hindi"
	, hmn: "Hmong"
	, ig: "Igbo"
	, ilo: "Ilokano"
	, id: "Indonesisch"
	, ga: "Irisch"
	, is: "Isländisch"
	, it: "Italienisch"
	, ja: "Japanisch"
	, jw: "Javanisch"
	, yi: "Jiddisch"
	, kn: "Kannada"
	, kk: "Kasachisch"
	, ca: "Katalanisch"
	, km: "Khmer"
	, rw: "Kinyarwanda"
	, ky: "Kirgisisch"
	, gom: "Konkani"
	, ko: "Koreanisch"
	, co: "Korsisch"
	, kri: "Krio"
	, hr: "Kroatisch"
	, ku: "Kurdisch (Kurmandschi)"
	, ckb: "Kurdisch (Sorani)"
	, lo: "Lao"
	, la: "Latein"
	, lv: "Lettisch"
	, ln: "Lingala"
	, lt: "Litauisch"}
     Return LanguageCodeArray[lang]
}
;--------------------------------------------
GetISOCodeB(lang) {
LanguageCodeArray := {  lg: "Luganda"
	, lb: "Luxemburgisch"
	, mai: "Maithili"
	, mg: "Malagasy"
	, ml: "Malayalam"
	, ms: "Malaysisch"
	, mt: "Maltesisch"
	, mi: "Maori"
	, mr: "Marathi"
	, mk: "Mazedonisch"
	, mni-Mtei: "Meitei (Manipuri)"
	, lus: "Mizo"
	, mn: "Mongolisch"
	, ne: "Nepalesisch"
	, nl: "Niederländisch"
	, no: "Norwegisch"
	, or: "Odia (Oriya)"
	, om: "Oromo"
	, ps: "Paschtu"
	, fa: "Persisch"
	, pl: "Polnisch"
	, pt: "Portugiesisch"
	, pa: "Punjabi"
	, qu: "Quechua"
	, ro: "Rumänisch"
	, ru: "Russisch"
	, sm: "Samoanisch"
	, sa: "Sanskrit"
	, gd: "Schottisch-Gälisch"
	, sv: "Schwedisch"
	, nso: "Sepedi"
	, sr: "Serbisch"
	, st: "Sesotho"
	, sn: "Shona"
	, sd: "Sindhi"
	, si: "Singhalesisch"
	, sk: "Slowakisch"
	, sl: "Slowenisch"
	, so: "Somali"
	, es: "Spanisch"
	, su: "Sundanesisch"
	, sw: "Swahili"
	, tg: "Tadschikisch"
	, ta: "Tamil"
	, tt: "Tatarisch"
	, te: "Telugu"
	, th: "Thailändisch"
	, ti: "Tigrinya"
	, cs: "Tschechisch"
	, ts: "Tsonga"
	, tr: "Türkisch"
	, tk: "Turkmenisch"
	, ak: "Twi"
	, ug: "Uigurisch"
	, uk: "Ukrainisch"
	, hu: "Ungarisch"
	, ur: "Urdu"
	, uz: "Usbekisch"
	, vi: "Vietnamesisch"
	, cy: "Walisisch"
	, xh: "Xhosa"
	, yo: "Yoruba"
	, zu: "Zulu"}
     Return LanguageCodeArray[lang]
}
;------------------------------------------------------------------
;GetGoogleLanguagesAndShortName:
GetGoogleLanguagesAndShortName() {
global
GoogleLanguageCodes =
(
Afrikaans	af
Albanisch	sq
Amharisch	am
Arabisch	ar
Armenisch	hy
Aserbaidschanisch	az
Assamesisch	as
Aymara	ay
Bambara	bm
Baskisch	eu
Belarussisch	be
Bengalisch	bn
Bhojpuri	bho
Birmanisch	my
Bosnisch	bs
Bulgarisch	bg
Cebuano	ceb
Chichewa	ny
Chinesisch_traditionell	zh-TW
Chinesisch_vereinfacht	zh-CN
Dänisch	da
Deutsch	de
Dhivehi	dv
Dogri	doi
Englisch	en
Esperanto	eo
Estnisch	et
Ewe	ee
Filipino	tl
Finnisch	fi
Französisch	fr
Friesisch	fy
Galizisch	gl
Georgisch	ka
Griechisch	el
Guarani	gn
Gujarati	gu
Haitianisch	ht
Hausa	ha
Hawaiisch	haw
Hebräisch	iw
Hindi	hi
Hmong	hmn
Igbo	ig
Ilokano	ilo
Indonesisch	id
Irisch	ga
Isländisch	is
Italienisch	it
Japanisch	ja
Javanisch	jw
Jiddisch	yi
Kannada	kn
Kasachisch	kk
Katalanisch	ca
Khmer	km
Kinyarwanda	rw
Kirgisisch	ky
Konkani	gom
Koreanisch	ko
Korsisch	co
Krio	kri
Kroatisch	hr
Kurdisch_Kurmandschi	ku
Kurdisch_Sorani	ckb
Lao	lo
Latein	la
Lettisch	lv
Lingala	ln
Litauisch	lt
Luganda	lg
Luxemburgisch	lb
Maithili	mai
Malagasy	mg
Malayalam	ml
Malaysisch	ms
Maltesisch	mt
Maori	mi
Marathi	mr
Mazedonisch	mk
Meitei_Manipuri	mni-Mtei
Mizo	lus
Mongolisch	mn
Nepalesisch	ne
Niederländisch	nl
Norwegisch	no
Odia_Oriya	or
Oromo	om
Paschtu	ps
Persisch	fa
Polnisch	pl
Portugiesisch	pt
Punjabi	pa
Quechua	qu
Rumänisch	ro
Russisch	ru
Samoanisch	sm
Sanskrit	sa
Schottisch_Gälisch	gd
Schwedisch	sv
Sepedi	nso
Serbisch	sr
Sesotho	st
Shona	sn
Sindhi	sd
Singhalesisch	si
Slowakisch	sk
Slowenisch	sl
Somali	so
Spanisch	es
Sundanesisch	su
Swahili	sw
Tadschikisch	tg
Tamil	ta
Tatarisch	tt
Telugu	te
Thailändisch	th
Tigrinya	ti
Tschechisch	cs
Tsonga	ts
Türkisch	tr
Turkmenisch	tk
Twi	ak
Uigurisch	ug
Ukrainisch	uk
Ungarisch	hu
Urdu	ur
Usbekisch	uz
Vietnamesisch	vi
Walisisch	cy
Xhosa	xh
Yoruba	yo
Zulu	zu
)
}
;Chinesisch (traditionell)	zh-TW
;Chinesisch (vereinfacht)	zh-CN
;Kurdisch (Kurmandschi)	ku
;Kurdisch (Sorani)	ckb
;------------------------------------------------------------------
;GetISOLanguageCodes:
GetISOLanguageCodes() {
global
LanguageCodes =
(
Afrikaans	Afrikaans	af	0436	Afrikaans
Albanian	Albanian	sq	041c	Albanisch
Algeria	Arabic_Algeria	ar	1401	Arabisch
Argentina	Spanish_Argentina	es	2c0a	Spanisch
Australian	English_Australian	en	0c09	Englisch
Austrian	German_Austrian	de	0c07	Deutsch
Azeri	Azeri_Cyrillic	az	082c	Aserbaidschanisch
Azeri	Azeri_Latin	az	042c	Aserbaidschanisch
Bahrain	Arabic_Bahrain	ar	3c01	Arabisch
Basque	Basque	eu	042d	Baskisch
Belarusian	Belarusian	be	0423	Belarussisch
Belgian	French_Belgian	fr	080c	Französisch
Belgian	Dutch_Belgian	nl	0813	Niederländisch
Belize	English_Belize	en	2809	Englisch
Bokmal	Norwegian_Bokmal	no	0414	Norwegisch
Bolivia	Spanish_Bolivia	es	400a	Spanisch
Brazilian	Portuguese_Brazilian	pt	0416	Portugiesisch
Brunei Darussalam	Malay_Brunei_Darussalam	ms	083e	Malaysisch
Bulgarian	Bulgarian	bg	0402	Bulgarisch
Canadian	English_Canadian	en	1009	Englisch
Canadian	French_Canadian	fr	0c0c	Französisch
Caribbean	English_Caribbean	en	2409	Englisch
Catalan	Catalan	ca	0403	Katalanisch
Chile	Spanish_Chile	es	340a	Spanisch
Colombia	Spanish_Colombia	es	240a	Spanisch
Costa Rica	Spanish_Costa_Rica	es	140a	Spanisch
Croatian	Croatian	hr	041a	Kroatisch
Czech	Czech	cs	0405	Tschechisch
Danish	Danish	da	0406	Dänisch
Dominican Republic	Spanish_Dominican_Republic	es	1c0a	Spanisch
Dutch	Dutch_Standard	nl	0413	Niederländisch
Ecuador	Spanish_Ecuador	es	300a	Spanisch
Egypt	Arabic_Egypt	ar	0c01	Arabisch
El Salvador	Spanish_El_Salvador	es	440a	Spanisch
Estonian	Estonian	et	0425	Estnisch
Finland	Swedish_Finland	sv	081d	Schwedisch
Finnish	Finnish	fi	040b	Finnisch
French	French_Standard	fr	040c	Französisch
Georgian	Georgian	ka	0437	Georgisch
German	German_Standard	de	0407	Deutsch
Greek	Greek	el	0408	Griechisch
Guatemala	Spanish_Guatemala	es	100a	Spanisch
Hebrew	Hebrew	iw	040d	Hebräisch
Hindi	Hindi	hi	0439	Hindi
Honduras	Spanish_Honduras	es	480a	Spanisch
Hong Kong	Chinese_Hong_Kong	zh-CN	0c04	Chinesisch (vereinfacht)
Hungarian	Hungarian	hu	040e	Ungarisch
Icelandic	Icelandic	is	040f	Isländisch
Indonesian	Indonesian	id	0421	Indonesisch
Iraq	Arabic_Iraq	ar	0801	Arabisch
Irish	English_Irish	en	1809	Englisch
Italian	Italian_Standard	it	0410	Italienisch
Jamaica	English_Jamaica	en	2009	Englisch
Japanese	Japanese	ja	0411	Japanisch
Jordan	Arabic_Jordan	ar	2c01	Arabisch
Korean	Korean	ko	0412	Koreanisch
Kuwait	Arabic_Kuwait	ar	3401	Arabisch
Latvian	Latvian	lv	0426	Lettisch
Lebanon	Arabic_Lebanon	ar	3001	Arabisch
Libya	Arabic_Libya	ar	1001	Arabisch
Liechtenstein	German_Liechtenstein	de	1407	Deutsch
Lithuanian	Lithuanian	lt	0427	Litauisch
Luxembourg	French_Luxembourg	fr	140c	Deutsch
Luxembourg	German_Luxembourg	de	1007	Französisch
Macau	Chinese_Macau	zh-CN	1404	Chinesisch (vereinfacht)
Macedonian	Macedonian	mk	042f	Mazedonisch
Malaysia	Malay_Malaysia	ms	043e	Malaysisch
Mexican	Spanish_Mexican	es	080a	Spanisch
Modern Sort	Spanish_Modern_Sort	es	0c0a	Spanisch
Monaco	French_Monaco	fr	180c	Französisch
Morocco	Arabic_Morocco	ar	1801	Arabisch
New Zealand	English_New_Zealand	en	1409	Englisch
Nicaragua	Spanish_Nicaragua	es	4c0a	Spanisch
Nynorsk	Norwegian_Nynorsk	no	0814	Norwegisch
Oman	Arabic_Oman	ar	2001	Arabisch
Panama	Spanish_Panama	es	180a	Spanisch
Paraguay	Spanish_Paraguay	es	3c0a	Spanisch
Peoples Republic of China	Chinese_PRC	zh-CN	0804	Chinesisch (vereinfacht)
Peru	Spanish_Peru	es	280a	Spanisch
Philippines	English_Philippines	en	3409	Englisch
Polish	Polish	pl	0415	Polnisch
Portuguese	Portuguese_Standard	pt	0816	Portugiesisch
Puerto Rico	Spanish_Puerto_Rico	es	500a	Spanisch
Romanian	Romanian	ro	0418	Rumänisch
Russian	Russian	ru	0419	Russisch
Saudi Arabia	Arabic_Saudi_Arabia	ar	0401	Arabisch
Serbian	Serbian_Cyrillic	sr	0c1a	Serbisch
Serbian Latin	Serbian_Latin	sr	081a	Serbisch
Singapore	Chinese_Singapore	zh-CN	1004	Chinesisch (vereinfacht)
Slovak	Slovak	sk	041b	Slowakisch
Slovenian	Slovenian	sl	0424	Slowenisch
South Africa	English_South_Africa	en	1c09	Englisch
Spanish	Spanish_Traditional_Sort	es	040a	Spanisch
Swahili	Swahili	sw	0441	Swahili
Swedish	Swedish	sv	041d	Schwedisch
Swiss	French_Swiss	fr	100c	Deutsch
Swiss	German_Swiss	de	0807	Französisch
Swiss	Italian_Swiss	it	0810	Italienisch
Syria	Arabic_Syria	ar	2801	Arabisch
Taiwan	Chinese_Taiwan	zh-CN	0404	Chinesisch (vereinfacht)
Tamil	Tamil	ta	0449	Tamil
Thai	Thai	th	041e	Thailändisch
Trinidad	English_Trinidad	en	2c09	Englisch
Tunisia	Arabic_Tunisia	ar	1c01	Arabisch
Turkish	Turkish	tr	041f	Türkisch
Ukrainian	Ukrainian	uk	0422	Ukrainisch
United Arab Emirates	Arabic_UAE	ar	3801	Arabisch
United Kingdom	English_United_Kingdom	en	0809	Englisch
United States	English_United_States	en	0409	Englisch
Urdu	Urdu	ur	0420	Urdu
Uruguay	Spanish_Uruguay	es	380a	Spanisch
Venezuela	Spanish_Venezuela	es	200a	Spanisch
Vietnamese	Vietnamese	vi	042a	Vietnamesisch
Yemen	Arabic_Yemen	ar	2401	Arabisch
Zimbabwe	English_Zimbabwe	en	3009	Englisch
)
}


;GetWin10LanguagePacks:
GetWin10LanguagePacks() {
global
Win10LanguagePacks =
(
Sprache	Name in Landessprache	Erforderliche Basissprache
Afrikaans	Afrikaans	English (United States)
Albanisch	Shqip	English (United States)
Amharisch	አማርኛ	English (United States) 
Arabisch	Arabisch	Jede Sprache
Armenisch	Հայերեն	English (United States)
Assamesisch	অসমীয়া	English (United States) 
Aserbaidschanisch (Lateinisch)	Azərbaycan	English (United States)
Bangla (Bangladesch)	বাংলা (ভারত)	English (United States) 
Bangla (Indien)	বাংলা (ভারত)	English (United States) 
Baskisch	Euskara	Spanisch (Spanien)
Belarussisch	беларуская мова	Russisch
Bosnisch (Lateinisch)	Bosanski	English (United States)
Bulgarisch	Bulgarisch	Jede Sprache
Katalanisch	Català	Spanisch (Spanien)
Zentralkurdisch (Arabisch)	سۆرانی	English (United States)
Cherokee (Cherokee)	ᏣᎳᎩ ᎦᏬᏂᎯᏍᏗ	English (United States)
Chinesisch (vereinfacht)	中文(简体)	Jede Sprache
Chinesisch (traditionell)	中文(繁體)	Jede Sprache
Kroatisch	Hrvatski	Jede Sprache
Tschechisch	Čeština	Jede Sprache
Dänisch	Dansk	Jede Sprache
Dari	درى	English (United States) 
Niederländisch	Nederlands	Jede Sprache
English	English	Jede Sprache
Estnisch	Eesti	Jede Sprache
Philippinisch	Philippinisch	English (United States) 
Finnisch	Suomi	Jede Sprache
Französisch	Français	Jede Sprache
Galicisch	Galego	Spanisch (Spanien)
Georgisch	ქართული	English (United States)
Deutsch	Deutsch	Jede Sprache
Griechisch	Griechisch	Jede Sprache
Gujarati	ગુજરાતી	English (United States) 
Haussa (Lateinisch)	Haussa	English (United States)
Hebräisch	עברית	Jede Sprache
Hindi	हिंदी	English (United States)
Ungarisch	Magyar	Jede Sprache
Isländisch	Íslenska	English (United States)
Igbo	Ndi Igbo	English (United States)
Indonesisch	Bahasa Indonesia	English (United States)
Irisch	Gaeilge	English (United States)
isiXhosa	isiXhosa	English (United States)
isi Zulu	isi Zulu	English (United States)
Italienisch	Italiano	Jede Sprache
Japanisch	日本語‫	Jede Sprache
Kannada	ಕನ್ನಡ	English (United States) 
Kasachisch	Қазақ	English (United States)
Khmer	ខ្មែរ	English (United States)
K'iche'	Qatzijob'al	Spanisch (Mexiko)
Kinyarwanda	Ikinyarwanda	English (United States)
Suaheli	Kiswahili	English (United States)
Konkani	कोंकणी	English (United States)
Koreanisch	한국어‫	Jede Sprache
Kirgisisch	Кыргыз	Russisch
Lettisch	Latviešu	Jede Sprache
Litauisch	Lietuvių	Jede Sprache
Luxemburgisch	Lëtzebuergesch	Französisch
Mazedonisch	македонски јазик	English (United States)
Malaiisch (Malaysia, Brunei und Singapur)	Bahasa Melayu	English (United States)
Malayalam	മലയാളം	English (United States)
Maltesisch	Malti	English (United States)
Maori	Te Reo Māori	English (United States)
Marathi	मराठी	English (United States)
Mongolisch (Kyrillisch)	Монгол хэл	English (United States)
Nepali	नेपाली	English (United States)
Norwegisch (Bokmål)	norsk (bokmål)	Jede Sprache
Norwegisch (Nynorsk)	Norsk (Nynorsk)	Norwegisch (Bokmål)
Odia	ଓଡିଆ	English (United States)
Persisch	فارسی	English (United States)
Polnisch	Polski	Jede Sprache
Portugiesisch (Brasilien)	Português	Jede Sprache
Portugiesisch (Portugal)	Português	Jede Sprache
Punjabi	ਪੰਜਾਬੀ	English (United States)
Punjabi (Arabisch)	پنجابی	English (United States)
Quechua	Runasimi	Spanisch (Mexiko)
Rumänisch	Română	Jede Sprache
Russisch	Русский	Jede Sprache
Schottisches Gälisch	Gàidhlig	English (United States)
Serbisch (Kyrillisch) – Bosnien und Herzegowina	српски	English (United States)
Serbisch (Kyrillisch, Serbien)	српски	Serbisch (Lateinisch)
Serbisch (Lateinisch)	Srpski	Jede Sprache
Sesotho sa Leboa	Sesotho sa Leboa	English (United States)
Setswana (Südafrika und Botsuana)	Tswana	English (United States) 
Sindhi (Arabisch)	سنڌي	English (United States)
Singhalesisch	සිංහල	English (United States)
Slowakisch	Slovenčina	Jede Sprache
Slowenisch	Slovenski	Jede Sprache
Spanisch	Español	Jede Sprache
Schwedisch	Svenska	Jede Sprache
Tadschikisch (Kyrillisch)	тоҷикӣ	Russisch
Tamil (Indien und Sri Lanka)	தமிழ்	English (United States)
Tatarisch	Татар	Russisch
Telugu	తెలుగు	English (United States)
Thailändisch	ไทย	Jede Sprache
Tigrinya (Äthiopien)	ትግርኛ	English (United States)
Türkisch	Türkçe	Jede Sprache
Turkmenisch	Türkmençe	Russisch
Ukrainisch	українська	Jede Sprache
Urdu	اردو	English (United States)
Uigurisch	ئۇيغۇرچە	Vereinfachtes Chinesisch (China)
Usbekisch (Lateinisch)	O'zbekcha	English (United States)
Valencianisch	Valencià	Spanisch (Spanien)
Vietnamesisch	Tiếng Việt	English (United States)
Walisisch	Cymraeg	English (United States)
Wolof	Wolof	Französisch
Yoruba	ede YorÙbá	English (United States)
)
}

;GetWin11LanguagePacks:
GetWin11LanguagePacks() {
global
Win11LanguagePacks =
(
Sprache	Name in Landessprache	Erforderliche Basissprache
Afrikaans	Afrikaans	English (United States)
Albanisch	Shqip	English (United States)
Amharisch	አማርኛ	English (United States) 
Arabisch	Arabisch	Jede Sprache
Armenisch	Հայերեն	English (United States)
Assamesisch	অসমীয়া	English (United States) 
Aserbaidschanisch (Lateinisch)	Azərbaycan	English (United States)
Bangla (Indien)	বাংলা (ভারত)	English (United States) 
Baskisch	Euskara	Spanisch (Spanien)
Belarussisch	беларуская мова	Russisch
Bosnisch (Lateinisch)	Bosanski	English (United States)
Bulgarisch	Bulgarisch	Jede Sprache
Katalanisch	Català	Spanisch (Spanien)
Cherokee (Cherokee)	ᏣᎳᎩ ᎦᏬᏂᎯᏍᏗ	English (United States)
Chinesisch (vereinfacht)	中文(简体)	Jede Sprache
Chinesisch (traditionell)	中文(繁體)	Jede Sprache
Kroatisch	Hrvatski	Jede Sprache
Tschechisch	Čeština	Jede Sprache
Dänisch	Dansk	Jede Sprache
Niederländisch	Nederlands	Jede Sprache
English	English	Jede Sprache
Estnisch	Eesti	Jede Sprache
Philippinisch	Philippinisch	English (United States) 
Finnisch	Suomi	Jede Sprache
Französisch	Français	Jede Sprache
Galicisch	Galego	Spanisch (Spanien)
Georgisch	ქართული	English (United States)
Deutsch	Deutsch	Jede Sprache
Griechisch	Griechisch	Jede Sprache
Gujarati	ગુજરાતી	English (United States) 
Hebräisch	עברית	Jede Sprache
Hindi	हिंदी	English (United States)
Ungarisch	Magyar	Jede Sprache
Isländisch	Íslenska	English (United States)
Indonesisch	Bahasa Indonesia	English (United States)
Irisch	Gaeilge	English (United States)
Italienisch	Italiano	Jede Sprache
Japanisch	日本語‫	Jede Sprache
Kannada	ಕನ್ನಡ	English (United States) 
Kasachisch	Қазақ	English (United States)
Khmer	ខ្មែរ	English (United States)
Konkani	कोंकणी	English (United States)
Koreanisch	한국어‫	Jede Sprache
Lettisch	Latviešu	Jede Sprache
Litauisch	Lietuvių	Jede Sprache
Luxemburgisch	Lëtzebuergesch	Französisch
Mazedonisch	македонски јазик	English (United States)
Malaiisch (Malaysia, Brunei und Singapur)	Bahasa Melayu	English (United States)
Malayalam	മലയാളം	English (United States)
Maltesisch	Malti	English (United States)
Maori	Te Reo Māori	English (United States)
Marathi	मराठी	English (United States)
Nepali	नेपाली	English (United States)
Norwegisch (Bokmål)	norsk (bokmål)	Jede Sprache
Norwegisch (Nynorsk)	Norsk (Nynorsk)	Norwegisch (Bokmål)
Odia	ଓଡିଆ	English (United States)
Persisch	فارسی	English (United States)
Polnisch	Polski	Jede Sprache
Portugiesisch (Brasilien)	Português	Jede Sprache
Portugiesisch (Portugal)	Português	Jede Sprache
Punjabi (Arabisch)	پنجابی	English (United States)
Quechua	Runasimi	Spanisch (Mexiko)
Rumänisch	Română	Jede Sprache
Russisch	Русский	Jede Sprache
Schottisches Gälisch	Gàidhlig	English (United States)
Serbisch (Kyrillisch) – Bosnien und Herzegowina	српски	English (United States)
Serbisch (Kyrillisch, Serbien)	српски	Serbisch (Lateinisch)
Serbisch (Lateinisch)	Srpski	Jede Sprache
Slowakisch	Slovenčina	Jede Sprache
Slowenisch	Slovenski	Jede Sprache
Spanisch	Español	Jede Sprache
Schwedisch	Svenska	Jede Sprache
Tamil (Indien und Sri Lanka)	தமிழ்	English (United States)
Tatarisch	Татар	Russisch
Telugu	తెలుగు	English (United States)
Thailändisch	ไทย	Jede Sprache
Türkisch	Türkçe	Jede Sprache
Ukrainisch	українська	Jede Sprache
Urdu	اردو	English (United States)
Uigurisch	ئۇيغۇرچە	Vereinfachtes Chinesisch (China)
Usbekisch (Lateinisch)	O'zbekcha	English (United States)
Valencianisch	Valencià	Spanisch (Spanien)
Vietnamesisch	Tiếng Việt	English (United States)
Walisisch	Cymraeg	English (United States)
)
}
