
/*

; https://www.autohotkey.com/boards/viewtopic.php?f=6&t=63835&start=40#p316637
; teadrinker: Ich habe versucht, mp3 aus dem Speicher abzuspielen. Es stellte sich als etwas umständlich heraus. :)

; https://docs.microsoft.com/en-us/windows/win32/medfound/player-cpp

#NoEnv
SetBatchLines, -1

text := "not`r`nsignificant      """
text := "heute haun wir auf die pauke      """
text = heute haun wir auf die pauke
text := clipboard

if !pIStream := GetMp3StreamFromGoogle(text, "de") {
   MsgBox, Failed to create stream!
   ExitApp
}
Session := new MediaSession()
Session.InitializeWithStream(pIStream)
ObjRelease(pIStream)
Session.Start()
Return

$F1:: Session.Start()
$F2:: Session.Pause()
$F3:: Session.Stop()

Esc:: ExitApp
*/



class MediaSession {
   __New() {
      static MF_VERSION := 0x2, MFSTARTUP_NOSOCKET := 0x1
      DllCall("Mfplat\MFStartup", "UInt", MF_VERSION, "UInt", MFSTARTUP_NOSOCKET, "UInt")
      this.MFSession := IMFMediaSession.Create()
   }
   __Delete() {
      this.Topology := ""
      this.PresentationDescriptor := ""
      this.MediaSource := ""

      this.MFSession.Shutdown()
      this.MFSession := ""
      DllCall("Mfplat\MFShutdown")
   }
   InitializeWithStream(pIStream, fileType := "mp3") {
      static MF_RESOLUTION_MEDIASOURCE := 1
      SourceResolver := IMFSourceResolver.Create()
      ByteStream := IMFByteStream.CreateFromStream(pIStream)

      this.MediaSource := SourceResolver.CreateObjectFromByteStream( ByteStream.ptr, "file." . fileType
                                                                   , MF_RESOLUTION_MEDIASOURCE, 0, MF_OBJECT_TYPE )
      SourceResolver := ByteStream := ""

      this.PresentationDescriptor := this.MediaSource.CreatePresentationDescriptor()
      this.Topology := IMFTopology.Create()
      descriptorCount := this.PresentationDescriptor.GetStreamDescriptorCount()
      Loop % descriptorCount
         this._AddBranchToPartialTopology(A_Index - 1)
      this.MFSession.SetTopology(0, this.Topology.ptr)
   }
   Start(atBeginning := true) {
      VarSetCapacity(GUID_NULL, 16, 0)
      VarSetCapacity(PROPVARIANT, 8 + A_PtrSize*2, 0)
      state := this.GetState()
      if atBeginning
         NumPut(VT_I8 := 0x14, PROPVARIANT, "UShort")
      this.MFSession.Start(&GUID_NULL, &PROPVARIANT)
   }
   Pause() {
      state := this.GetState()
      if (state != 1)
         this.Start(false)
      else
         this.MFSession.Pause()
   }
   Stop() {
      this.MFSession.Stop()
   }
   GetState() {
      Clock := this.MFSession.GetClock()
      Return Clock.GetState()
   }
   _AddBranchToPartialTopology(i) {
      static MFMediaType_Audio := "{73647561-0000-0010-8000-00AA00389B71}"
      StreamDescriptor := this.PresentationDescriptor.GetStreamDescriptorByIndex(i, selected)
      if selected {
         MediaTypeHandler := StreamDescriptor.GetMediaTypeHandler()
         VarSetCapacity(GUID, 16, 0)
         MediaTypeHandler.GetMajorType(GUID)
         if StringFromGUID(GUID) = MFMediaType_Audio
            MFActivate := IMFActivate.Create()
         SourceTopologyNode := this._AddSourceNode(StreamDescriptor)
         OutputTopologyNode := this._AddOutputNode(MFActivate)
         SourceTopologyNode.ConnectOutput(0, OutputTopologyNode.ptr, 0)
      }
   }
   _AddSourceNode(StreamDescriptor) {
      static MF_TOPOLOGY_SOURCESTREAM_NODE := 1
           , MF_TOPONODE_SOURCE                  := "{835C58EC-E075-4BC7-BCBA-4DE000DF9AE6}"
           , MF_TOPONODE_PRESENTATION_DESCRIPTOR := "{835C58ED-E075-4BC7-BCBA-4DE000DF9AE6}"
           , MF_TOPONODE_STREAM_DESCRIPTOR       := "{835C58EE-E075-4BC7-BCBA-4DE000DF9AE6}"
      SourceTopologyNode := IMFTopologyNode.Create(MF_TOPOLOGY_SOURCESTREAM_NODE)
      SourceTopologyNode.SetUnknown( CLSIDFromString(MF_TOPONODE_SOURCE                 , GUID), this.MediaSource.ptr )
      SourceTopologyNode.SetUnknown( CLSIDFromString(MF_TOPONODE_PRESENTATION_DESCRIPTOR, GUID), this.PresentationDescriptor.ptr )
      SourceTopologyNode.SetUnknown( CLSIDFromString(MF_TOPONODE_STREAM_DESCRIPTOR      , GUID), StreamDescriptor.ptr )
      this.Topology.AddNode(SourceTopologyNode.ptr)
      Return SourceTopologyNode
   }
   _AddOutputNode(MFActivate) {
      static MF_TOPOLOGY_OUTPUT_NODE := 0
           , MF_TOPONODE_STREAMID             := "{14932F9B-9087-4BB4-8412-5167145CBE04}"
           , MF_TOPONODE_NOSHUTDOWN_ON_REMOVE := "{14932F9C-9087-4BB4-8412-5167145CBE04}"
      OutputTopologyNode := IMFTopologyNode.Create(MF_TOPOLOGY_OUTPUT_NODE)
      OutputTopologyNode.SetObject(MFActivate.ptr)
      OutputTopologyNode.SetUINT32( CLSIDFromString(MF_TOPONODE_STREAMID            , GUID), 0 )
      OutputTopologyNode.SetUINT32( CLSIDFromString(MF_TOPONODE_NOSHUTDOWN_ON_REMOVE, GUID), 0 )
      this.Topology.AddNode(OutputTopologyNode.ptr)
      Return OutputTopologyNode
   }
}

class IMFMediaSession extends InterfaceBase {
   Create() {
      DllCall("Mf\MFCreateMediaSession", "Ptr", 0, "PtrP", pIMFMediaSession)
      Return new IMFMediaSession(pIMFMediaSession)
   }
   SetTopology(flags, pIMFTopology) {
      hr := DllCall(this.VTable(7), "Ptr", this.ptr, "UInt", flags, "Ptr", pIMFTopology)
      this.IsError("IMFMediaSession::SetTopology", hr)
   }
   Start(pGUID, pVariant) {
      hr := DllCall(this.VTable(9), "Ptr", this.ptr, "Ptr", pGUID, "Ptr", pVariant)
      this.IsError("IMFMediaSession::Start", hr)
   }
   Pause() {
      hr := DllCall(this.VTable(10), "Ptr", this.ptr)
      this.IsError("IMFMediaSession::Pause", hr)
   }
   Stop() {
      hr := DllCall(this.VTable(11), "Ptr", this.ptr)
      this.IsError("IMFMediaSession::Stop", hr)
   }
   Shutdown() {
      hr := DllCall(this.VTable(13), "Ptr", this.ptr)
      this.IsError("IMFMediaSession::Shutdown", hr)
   }
   GetClock() {
      hr := DllCall(this.VTable(14), "Ptr", this.ptr, "PtrP", pIMFClock)
      this.IsError("IMFMediaSession::GetClock", hr)
      Return new IMFClock(pIMFClock)
   }
}

class IMFClock extends InterfaceBase {
   GetState() {
      hr := DllCall(this.VTable(6), "Ptr", this.ptr, "UInt", 0, "UIntP", state)
      this.IsError("IMFClock::GetState", hr)
      Return state
   }
}

class IMFSourceResolver extends InterfaceBase {
   Create() {
      DllCall("Mfplat\MFCreateSourceResolver", "PtrP", pIMFSourceResolver)
      Return new IMFSourceResolver(pIMFSourceResolver)
   }
   CreateObjectFromByteStream(pIMFByteStream, URL, flags, pIPropertyStore, ByRef MF_OBJECT_TYPE) {
      static IID_IMFMediaSource := "{279A808D-AEC7-40C8-9C6B-A6B492C78A66}"
      hr := DllCall(this.VTable(4), "Ptr", this.ptr, "Ptr", pIMFByteStream, "WStr", URL, "UInt", flags
                                  , "Ptr", pIPropertyStore, "UIntP", MF_OBJECT_TYPE, "PtrP", pIUnknown)
      this.IsError("IMFSourceResolver::CreateObjectFromByteStream", hr)
      pIMFMediaSource := ComObjQuery(pIUnknown, IID_IMFMediaSource)
      ObjRelease(pIUnknown)
      Return new IMFMediaSource(pIMFMediaSource)
   }
}

class IMFByteStream extends InterfaceBase {
   CreateFromStream(pIStream) {
      hr := DllCall("Mfplat\MFCreateMFByteStreamOnStream", "Ptr", pIStream, "PtrP", pIMFByteStream)
      IMFByteStream.IsError("IMFByteStream::MFCreateMFByteStreamOnStream", hr)
      Return new IMFByteStream(pIMFByteStream)
   }
}

class IMFMediaSource extends InterfaceBase {
   CreatePresentationDescriptor() {
      hr := DllCall(this.VTable(8), "Ptr", this.ptr, "PtrP", pIMFPresentationDescriptor)
      this.IsError("IMFMediaSource::CreatePresentationDescriptor", hr)
      Return new IMFPresentationDescriptor(pIMFPresentationDescriptor)
   }
}

class IMFPresentationDescriptor extends InterfaceBase {
   GetStreamDescriptorCount() {
      hr := DllCall(this.VTable(33), "Ptr", this.ptr, "UIntP", descriptorCount)
      this.IsError("IMFPresentationDescriptor::GetStreamDescriptorCount", hr)
      Return descriptorCount
   }
   GetStreamDescriptorByIndex(idx, ByRef selected) {
      hr := DllCall(this.VTable(34), "Ptr", this.ptr, "UInt", idx, "UIntP", selected, "PtrP", pIMFStreamDescriptor)
      this.IsError("IMFPresentationDescriptor::GetStreamDescriptorByIndex", hr)
      Return new IMFStreamDescriptor(pIMFStreamDescriptor)
   }
}

class IMFTopology extends InterfaceBase {
   Create() {
      DllCall("Mf\MFCreateTopology", "PtrP", pIMFTopology)
      Return new IMFTopology(pIMFTopology)
   }
   AddNode(pNode) {
      hr := DllCall(this.VTable(34), "Ptr", this.ptr, "Ptr", pNode)
      this.IsError("IMFTopology::AddNode", hr)
   }
}

class IMFStreamDescriptor extends InterfaceBase {
   GetMediaTypeHandler() {
      hr := DllCall(this.VTable(34), "Ptr", this.ptr, "PtrP", pIMFMediaTypeHandler)
      this.IsError("IMFStreamDescriptor::GetMediaTypeHandler", hr)
      Return new IMFMediaTypeHandler(pIMFMediaTypeHandler)
   }
}

class IMFMediaTypeHandler extends InterfaceBase {
   GetMajorType(ByRef GUID) {
      hr := DllCall(this.VTable(8), "Ptr", this.ptr, "Ptr", &GUID)
      this.IsError("IMFMediaTypeHandler::GetMajorType", hr)
   }
}

class IMFActivate extends InterfaceBase {
   Create() {
      hr := DllCall("Mf\MFCreateAudioRendererActivate", "PtrP", pIMFActivate)
      Return new IMFActivate(pIMFActivate)
   }
}

class IMFTopologyNode extends InterfaceBase {
   Create(type) {
      hr := DllCall("Mf\MFCreateTopologyNode", "UInt", type, "PtrP", pIMFTopologyNode)
      IMFTopologyNode.IsError("IMFTopologyNode::Create", hr)
      Return new IMFTopologyNode(pIMFTopologyNode)
   }
   SetUINT32(riid, value) {
      hr := DllCall(this.VTable(21), "Ptr", this.ptr, "Ptr", riid, "UInt", value)
      this.IsError("IMFTopologyNode::SetUINT32", hr)
   }
   SetUnknown(riid, pi) {
      hr := DllCall(this.VTable(27), "Ptr", this.ptr, "Ptr", riid, "Ptr", pi)
      this.IsError("IMFTopologyNode::SetUnknown", hr)
   }
   SetObject(pi) {
      hr := DllCall(this.VTable(33), "Ptr", this.ptr, "Ptr", pi)
      this.IsError("IMFTopologyNode::SetObject", hr)
   }
   ConnectOutput(OutputIndex, pDownstreamNode, dwInputIndexOnDownstreamNode) {
      hr := DllCall(this.VTable(40), "Ptr", this.ptr, "UInt", OutputIndex
                                   , "Ptr", pDownstreamNode, "UInt", dwInputIndexOnDownstreamNode)
      this.IsError("IMFTopologyNode::ConnectOutput", hr)
   }
}

class InterfaceBase {
   __New(ptr) {
      this.ptr := ptr
   }
   __Delete() {
      ObjRelease(this.ptr)
   }
   VTable(idx) {
      Return NumGet(NumGet(this.ptr + 0) + A_PtrSize*idx)
   }
   IsError(method, result, exc := true) {
      if (result = 0)
         Return 0
      this.error := method . " failed. Result: " . ( result = "" ? "No result" : Format("{:#x}", result & 0xFFFFFFFF) )
                              . "`nErrorLevel: " . ErrorLevel
      if !exc
         Return this.error
      throw Exception(this.error)
   }
}

StringFromGUID(ByRef VarOrAddress) {
   pGuid := IsByRef(VarOrAddress) ? &VarOrAddress : VarOrAddress
   VarSetCapacity(sGuid, 78) ; (38 + 1) * 2
   if !DllCall("ole32\StringFromGUID2", "Ptr", pGuid, "Ptr", &sGuid, "Int", 39)
      throw Exception("Invalid GUID", -1, Format("<at {1:p}>", pGuid))
   return StrGet(&sGuid, "UTF-16")
}

CLSIDFromString(IID, ByRef CLSID) {
   VarSetCapacity(CLSID, 16, 0)
   if res := DllCall("ole32\CLSIDFromString", "WStr", IID, "Ptr", &CLSID, "UInt")
      throw Exception("CLSIDFromString failed. Error: " . Format("{:#x}", res))
   Return &CLSID
}

GetMp3StreamFromGoogle(text, lng) {
   static hHeap := DllCall("GetProcessHeap", "Ptr")
        , flags := (HEAP_NO_SERIALIZE := 0x1) | (HEAP_ZERO_MEMORY := 0x8)
   if ( (text := Trim(text, " `t`n`r")) = "" ) {
      MsgBox, String is empty
      Return
   }
   chunks := [], text .= ".", pos := 1
   Loop {
      for k, v in ["\.", "!", "\?", ";", ",", ":", "\(", "\)", " ", "$"]
         RegExMatch(SubStr(text, pos, 200), "sO).+" . v . "+", m)
      until m.Len
      chunks.Push(m[0])
      pos += m.Len
   } until pos > StrLen(text)
   last := chunks.Pop()
   chunks.Push( SubStr(last, 1, -1) )

   size := offset := 0
   for k, v in chunks {
      url := __CreateUrl(v, lng)
      arr := __SendRequest(url)
      pData := NumGet(ComObjValue(arr) + 8 + A_PtrSize)
      length := arr.MaxIndex() + 1
      size += length
      if (A_Index = 1)
         pHeap := DllCall("HeapAlloc", "Ptr", hHeap, "UInt", flags, "Ptr", size, "Ptr")
      else
         pHeap := DllCall("HeapReAlloc", "Ptr", hHeap, "UInt", flags, "Ptr", pHeap, "Ptr", size, "Ptr")
      DllCall("RtlMoveMemory", "Ptr", pHeap + offset, "Ptr", pData, "Ptr", length)
      offset := size
   }
   pIStream := DllCall("Shlwapi\SHCreateMemStream", "Ptr", pHeap, "UInt", offset, "Ptr")
   DllCall("HeapFree", "Ptr", hHeap, "UInt", 0, "Ptr", pHeap)
   Return pIStream
}

__CreateUrl(text, lng)  {
   JS := GetJS(), JS.( __GetJScript() )
   url := "https://translate.google.ru/translate_tts?ie=UTF-8&tl="
         . lng . "&total=1&idx=0&client=t&prev=input&textlen="
         . StrLen(text) . "&tk=" . JS.("tk").(text) . "&q=" . __URIEncode(text)
   Return url
}

__SendRequest(url) {
   whr := ComObjCreate("Msxml2.XMLHTTP.6.0")
   whr.Open("GET", url, false)
   whr.Send()
   
   if (whr.Status != 200)
      Return "Error! Status: " . whr.Status . "`n`n" . whr.responseBody
   Return whr.responseBody
}

GetJS() {
   static doc := ComObjCreate("htmlfile")
        , __ := doc.write("<meta http-equiv='X-UA-Compatible' content='IE=9'>")
        , JS := ObjBindMethod(doc.parentWindow, "eval")
   Return JS
}

__URIEncode(str, encoding := "UTF-8")  {
   VarSetCapacity(var, StrPut(str, encoding))
   StrPut(str, &var, encoding)
   While code := NumGet(Var, A_Index - 1, "UChar")  {
      bool := (code > 0x7F || code < 0x30 || code = 0x3D)
      UrlStr .= bool ? "%" . Format("{:02X}", code) : Chr(code)
   }
   Return UrlStr
}

__GetJScript()
{
   script =
   (
      var TKK = ((function() {
        var a = 561666268;
        var b = 1526272306;
        return 406398 + '.' + (a + b);
      })());

      function b(a, b) {
        for (var d = 0; d < b.length - 2; d += 3) {
            var c = b.charAt(d + 2),
                c = "a" <= c ? c.charCodeAt(0) - 87 : Number(c),
                c = "+" == b.charAt(d + 1) ? a >>> c : a << c;
            a = "+" == b.charAt(d) ? a + c & 4294967295 : a ^ c
        }
        return a
      }

      function tk(a) {
          for (var e = TKK.split("."), h = Number(e[0]) || 0, g = [], d = 0, f = 0; f < a.length; f++) {
              var c = a.charCodeAt(f);
              128 > c ? g[d++] = c : (2048 > c ? g[d++] = c >> 6 | 192 : (55296 == (c & 64512) && f + 1 < a.length && 56320 == (a.charCodeAt(f + 1) & 64512) ?
              (c = 65536 + ((c & 1023) << 10) + (a.charCodeAt(++f) & 1023), g[d++] = c >> 18 | 240,
              g[d++] = c >> 12 & 63 | 128) : g[d++] = c >> 12 | 224, g[d++] = c >> 6 & 63 | 128), g[d++] = c & 63 | 128)
          }
          a = h;
          for (d = 0; d < g.length; d++) a += g[d], a = b(a, "+-a^+6");
          a = b(a, "+-3^+b+-f");
          a ^= Number(e[1]) || 0;
          0 > a && (a = (a & 2147483647) + 2147483648);
          a `%= 1E6;
          return a.toString() + "." + (a ^ h)
      }
   )
   Return script
}